#include "includes.h"

#define TIMEOUT 20
#define LOCKFILE "/.lock"

/* lock and unlock the bug tracking system */

static int locked;
extern int guest;

void lock_system(void)
{
	int i;
	int fd;
	int pid = getpid();

	if (guest) return;

	if (locked) {
		locked++;
		return;
	}

	for (i=0;i<TIMEOUT;i++) {
		fd = open(LOCKFILE, O_EXCL | O_CREAT | O_WRONLY, 0644);
		if (fd != -1) {
			write(fd, &pid, sizeof(pid));
			close(fd);
			locked = 1;
			return;
		}
		sleep(1);
	}
	
	/* damn, something probably died while it was locked. We'll
	   claim the lock for ourselves so that we can recover */
	locked = 1;
}

void unlock_system(void)
{
	if (guest) return;

	if (locked > 1) {
		locked--;
		return;
	}

	if (locked)
		unlink(LOCKFILE);
	locked = 0;
}
